/* fasta.h
 * Declarations for simple FASTA i/o library
 * SRE, Sun Sep  8 05:37:38 2002 [AA2721, transatlantic]
 * CVS $Id$
 */

// qx: src from http://www.cse.msu.edu/~cse891/Sect001/hw1-codes


//extern FASTAFILE *OpenFASTA(char *seqfile);
//extern int
//ReadFASTA(FASTAFILE *fp, char **ret_seq, char **ret_name, int *ret_L);
//extern void CloseFASTA(FASTAFILE *ffp);

#include "Parser.h"

class FastqParser: public Parser {

private:
	//int ReadFASTA(FASTAFILE *ffp, string & name, char **ret_seq,
	//		FilePosition *retNamePos, int *retNameLen, int *ret_L);
	//int ReadFASTA(FASTAFILE *ffp, string & name, Entry * entry);

	int nalloc;
	char *seq;

public:

	virtual void init() {
		nalloc = 128;
		seq = (char*) malloc(sizeof(char) * nalloc); /* allocate seq in blocks of 128 residues */
	}

	~FastqParser(){
		free(seq);
		seq = 0;
	}

	bool isReadStart(string line) {
		return line.length() > 0 && line[0] == '@';
	}

	virtual int getMaxReadLength(int & readCount, FilePosition & fileSize);

	virtual bool read(string & name, Entry * entry);

	virtual char const * getFormatName();

};
