/*
 * NgmWriter.cpp
 *
 *  Created on: May 4, 2011
 *      Author: philipp_
 */

#include "NgmReadWriter.h"

#include <iomanip>
#include <string>

using std::string;

NgmReadWriter::NgmReadWriter(char const * const fileName) :
	NgmWriter(sig, entryLength, fileName) {

}

NgmReadWriter::~NgmReadWriter() {
	// TODO Auto-generated destructor stub
}

FilePosition NgmReadWriter::writeRead(char  * const sequence,
		int const maxReadLength) {
	FilePosition outputPosition = data.tellp();
	toUpperCase(sequence, maxReadLength);
	data << std::left << std::setw(maxReadLength) << std::setfill('\0')
			<< sequence << std::setw(0) << '\0';
	return outputPosition;
}

FilePosition NgmReadWriter::writeDummy(int const maxReadLength) {
	char * const dummy = (char * const)string(maxReadLength, 'X').c_str();
	return writeRead(dummy, maxReadLength);
}

void NgmReadWriter::writeIndexEntryRead(Entry const * entryLeft, bool isValid) {
	if (entryLeft != 0) {
		int flags = 0;
		if (isValid) {
			flags = flags | 1;
		}

		idx.write((char*) &sequenceId, 4);
		idx.write((char*) &flags, 4);
		idx.write((char*) &entryLeft->nameOffset, 8);
		idx.write((char*) &entryLeft->qualityOffset, 8);
		idx.write((char*) &entryLeft->nameLength, 4);
		idx.write((char*) &entryLeft->qualityLength, 4);

		sequenceId += 1;
	} else {
		throw "Two empty entries passed to function writeIndexEntryread";
	}
}

void NgmReadWriter::reWriteReadHeader(int const maxReadLength,
		int const readCount, int const flags, unsigned int const checksum) {
	idx.seekp(std::ios_base::beg);
	writeReadHeader(maxReadLength, readCount, flags, checksum);
}

void NgmReadWriter::writeReadHeader(int const maxReadLength,
		int const readCount, int const flags, unsigned int const checksum) {
	WriteHeader(readCount, maxReadLength + 1, flags, checksum);
}
