/*
 * NgmWriter.h
 *
 *  Created on: May 4, 2011
 *      Author: philipp_
 */

#ifndef NGMWRITER_H_
#define NGMWRITER_H_

#include <fstream>
#include <string>
#include "datatypes.h"

using std::ofstream;

class NgmWriter {

private:
	// Note: On MSVC, compile with /Za (Disable Language Extensions)
	static int const version = 0x01010100;
	static int const headerLength = 32;

	int const sig;
	int const entryLength;

protected:
	ofstream idx;
	ofstream data;

	unsigned int sequenceId;

	void WriteHeader(unsigned int seqCount,
			unsigned int seqFieldWith, unsigned int flags,
			unsigned int checkSum);

	void toUpperCase(char * sequence, int sequenceLength);

public:
	NgmWriter(int const sig, int const entryLength,
			char const * const fileName);

	virtual ~NgmWriter();
};

#endif /* NGMWRITER_H_ */
