/*
 * datatypes.h
 *
 *  Created on: Mar 22, 2011
 *      Author: philipp_
 */

#ifndef DATATYPES_H_
#define DATATYPES_H_

#ifdef _WIN32
typedef unsigned long long FilePosition;
#else
typedef unsigned long FilePosition;
#endif

#define FASTA_MAXLINE 512	/* Requires FASTA file lines to be <512 characters */

struct Entry {
	Entry() {
		sequence = 0;
		qualityLength = 0;
		qualityOffset = 0;
		sequenceLength = 0;
		nameOffset = 0;
		nameLength = 0;
		first = true;
	}

	char * sequence;
	int sequenceLength;
	FilePosition nameOffset;
	int nameLength;
	FilePosition qualityOffset;
	int qualityLength;
	bool first;
};

typedef struct fastafile_s {
	FILE *fp;
	char buffer[FASTA_MAXLINE];
	FilePosition filePos;
} SEQFILE;

#endif /* DATATYPES_H_ */
