#ifndef __CSCACHE_H__
#define __CSCACHE_H__

#include <string>
#include <stdio.h>

#include "IRefProvider.h"
#include "Types.h"

struct CSCachePageIndex;

class CSCache : public IRefProvider
{
public:
	// Creates a new, empty cache file
	static CSCache * CreateCache(std::string const filename);
	// Loads a cache file
	static CSCache const * LoadCache(std::string const filename);

	// Adds a page containing the data in Table to the cache
	void AddPage(PrefixRefRelay * * Table, uint const length);

	// Loads a page into memory and sets it as current
	void LoadPage(int const page) const;
	// Gets number of pages in file
	int  GetPageCount() const;

	// Gets a list of positions for prefix
	// contained on the current page
	RefEntry * GetRefEntry(ulong prefix) const;

	~CSCache();
private:
	CSCache();

	mutable std::string m_Filename;
	mutable FILE * m_FP;
	mutable char * m_pMem;
	mutable CSCachePageIndex * m_Index;
	mutable int m_CurrentPage;
};


#endif
